Food Delivery zoj3469 区间dp

Description

When we are focusing on solving problems, we usually prefer to stay in front of computers rather than go out for lunch. At this time, we may call for food delivery.

Suppose there are N people living in a straight street that is just lies on an X-coordinate axis. The ith person’s coordinate is Xi meters. And in the street there is a take-out restaurant which has coordinates X meters. One day at lunchtime, each person takes an order from the restaurant at the same time. As a worker in the restaurant, you need to start from the restaurant, send food to the N people, and then come back to the restaurant. Your speed is V-1 meters per minute.

You know that the N people have different personal characters; therefore they have different feeling on the time their food arrives. Their feelings are measured by Displeasure Index. At the beginning, the Displeasure Index for each person is 0. When waiting for the food, the ith person will gain BiDispleasure Index per minute.

If one’s Displeasure Index goes too high, he will not buy your food any more. So you need to keep the sum of all people’s Displeasure Index as low as possible in order to maximize your income. Your task is to find the minimal sum of Displeasure Index.

Input

The input contains multiple test cases, separated with a blank line. Each case is started with three integers N ( 1 <= N <= 1000 ), V ( V > 0), X ( X >= 0 ), then N lines followed. Each line contains two integers Xi ( Xi >= 0 ), Bi ( Bi >= 0), which are described above.

You can safely assume that all numbers in the input and output will be less than 231 - 1.

Please process to the end-of-file.

Output

For each test case please output a single number, which is the minimal sum of Displeasure Index. One test case per line.

Sample Input

5 1 0

1 1

2 2

3 3

4 4

5 5

Sample Output

55

1)题意:有一家快餐店送外卖,现在同时有n个家庭打进电话订购,送货员得以V-1的速度一家一家的运送,但是每一个家庭都有一个不开心的值,每分钟都会增加一倍,值达到一定程度,该家庭将不会再订购外卖了,现在为了以后有更多的家庭订购,要将外卖送到的情况下使得所有用户的不开心值总和达到最小。

(2)解法:区间dp。很明显,每多走一分钟,没送到的家庭的不开心值都会加倍。假设是这样的顺序123X456,从X出发先往左右中间靠近的送,再往两边送省时间。dp[i][j][0]表示从i到j用户送到最小不开心值,此时送货员停留在左边即i位置。dp[i][j][1]表示从i到j用户送到最小不开心值,此时送货员停留在右边即j位置状态有四种:

1):dp[i][j][0]=min(dp[i][j][0],dp[i+1][j][0]+(a[i+1].x-a[i].x)*(delay+a[i].v));

2):dp[i][j][0]=min(dp[i][j][0],dp[i+1][j][1]+(a[j].x-a[i].x)*(delay+a[i].v));

3):dp[i][j][1]=min(dp[i][j][1],dp[i][j-1][0]+(a[j].x-a[i].x)*(delay+a[j].v));

4):dp[i][j][1]=min(dp[i][j][1],dp[i][j-1][1]+(a[j].x-a[j-1].x)*(delay+a[j].v));

#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<iostream>
#include<queue>
using namespace std;

long long int dp[1005][1005][2];
int sum[1005];

struct Rac{
    int x;
    int bu;
}order[1005];
bool cmp(struct Rac a,struct Rac b)
{
    return a.x<b.x;
}
int main()
{
    int n,v,qi;
    //freopen("a.txt","r",stdin);
    while(scanf("%d %d %d",&n,&v,&qi)==3)
    {
        int i,j;
        int zou;
        memset(sum,0,sizeof(sum));
        for(i=1;i<=n;i++)  scanf("%d %d",&order[i].x,&order[i].bu);
        n++;
        order[n].x=qi;
        order[n].bu=0;
        sort(order+1,order+n+1,cmp);
        for(i=1;i<=n;i++)  sum[i]=sum[i-1]+order[i].bu;

        for(i=1;i<=n;i++)
        {
            if(order[i].x==qi) zou=i;
        }
        for(i=1;i<=n;i++)
        {
            for(j=1;j<=n;j++)
            {
                dp[i][j][0]=dp[i][j][1]=1100000000;
            }
        }

        dp[zou][zou][0]=dp[zou][zou][1]=0;

        for(i=zou;i>=1;i--)
        {
            for(j=zou;j<=n;j++)
            {
                if(i==j) continue;

                // sum[i]+sum[n]-sum[j]//剩下没有送的。。+fuck*t
                dp[i][j][0]=min(dp[i][j][0],dp[i+1][j][0]+(order[i+1].x-order[i].x)*(sum[i]+sum[n]-sum[j]));
                dp[i][j][0]=min(dp[i][j][0],dp[i+1][j][1]+(order[j].x-order[i].x)*(sum[i]+sum[n]-sum[j]));
                dp[i][j][1]=min(dp[i][j][1],dp[i][j-1][1]+(order[j].x-order[j-1].x)*(sum[i-1]+sum[n]-sum[j-1]));
                dp[i][j][1]=min(dp[i][j][1],dp[i][j-1][0]+(order[j].x-order[i].x)*(sum[i-1]+sum[n]-sum[j-1]));
            }
        }
        printf("%d\n",min(dp[1][n][0],dp[1][n][1])*v);
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-11-26 01:43:51

Food Delivery zoj3469 区间dp的相关文章

ZOJ 3469 Food Delivery(区间DP)

题目链接:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=4255 题意:n个人订餐.n个人位于一条线上,饭店也在这条线上.每个人有一个脾气值p.若第i分钟得到他预定的饭不满意度为p*i.送饭人的速度已知.求一种送饭顺序使得总不满意度最小. 思路:设f[i][j][0],f[i] [j][1]分别表示将[i,j]区间的送完,最后停在左边或右边的最小不满意度.那么我们在DPf[i][j][0]时可以从f[i+1][j]进行转 移

ZOJ 3469 Food Delivery (区间DP,经典)

题意: 在x轴上有一家外卖餐馆,有n个顾客站在x轴上不同坐标上且叫了外卖,每个人的脾气不同,每1分钟没有收到外卖就会增加Fi点愤怒值,而外卖小哥的车是有速度的v-1/分钟,问怎样的送餐次序会让所有顾客的愤怒值之和最小?输出愤怒值之和! 思路: 此题是很经典了,比较现实的模型. 随便画画就知道小哥可以一下子往左一下子往右走,往返多次也是有可能的,取决于顾客的愤怒系数Fi.那么在考虑一个区间[L,R]时,其任一子区间都必须是已经被考虑过了.现在考虑区间[L,R]可以转移到哪里,明显可以分别转移到[L

ZOJ3469 Food Delivery (经典区间dp)

本题和某一年的oi题非常相似,都是经典套路 我们知道我们在送完食物后既可以向前送也可以回头送,这就体现了区间dp的思想 为什么我们这次的区间dp不用枚举第三维k来枚举从哪里送过来呢? 因为送货员不是傻子,他如果送到你这了,那么在你们两之间的可以都顺路送了,所以我们只需要枚举两个位置就行 这题的输入不一定递增,所以建议输入完后排序 #include<iostream> #include<cstdio> #include<cstring> #include<algor

ZOJ3541:The Last Puzzle(区间DP)

There is one last gate between the hero and the dragon. But opening the gate isn't an easy task. There were n buttons list in a straight line in front of the gate and each with an integer on it. Like other puzzles the hero had solved before, if all b

uva 10003 Cutting Sticks 简单区间dp

// uva 10003 Cutting Sticks 区间dp // 经典的区间dp // dp(i,j)表示切割小木棍i-j所需要的最小花费 // 则状态转移为dp(i,j) = min{dp(i,k) + dp(k,j) + a[j]-a[i]) // 其中k>i && k<j // a[j] - a[i] 为第一刀切割的代价 // a[0] = 0,a[n+1] = L; // dp数组初始化的时候dp[i][i+1]的值为 0,这表示 // 每一段都已经是切割了的,不

黑书例题 Fight Club 区间DP

题目可以在bnuoj.soj等OJ上找到. 题意: 不超过40个人站成一圈,只能和两边的人对战.给出任意两人对战的输赢,对于每一个人,输出是否可能是最后的胜者. 分析: 首先序列扩展成2倍,破环成链. dp[i][j]表示i和j能够相遇对打,那么dp[i][i+n]为真代表可以成为最后胜者. 枚举中间的k,若i和j都能和k相遇,且i和j至少一人能打赢k,那么i和j可以相遇. 复杂度o(n^3) 1 #include<cstdio> 2 #include<cstring> 3 usi

算法复习——区间dp

感觉对区间dp也不好说些什么直接照搬讲义了2333 例题: 1.引水入城(洛谷1514) 这道题先开始看不出来到底和区间dp有什么卵关系···· 首先肯定是bfs暴力判一判可以覆盖到哪些城市····无解直接输出···有解得话就要想想了···· 这道题关键是要发现··如果一个蓄水池所在城市可以覆盖到一些沙漠城市···那么这些沙漠城市肯定是一段····不然假设有一个城市是断开的而两边都被同一个蓄水池流出的水覆盖,这个城市四周的城市都肯定比它矮···(不理解举个反例吧···反正我举不出来)···然后就

合并石子 区间dp水题

合并石子 链接: nyoj 737 描述: 有N堆石子排成一排,每堆石子有一定的数量.现要将N堆石子并成为一堆.合并的过程只能每次将相邻的两堆石子堆成一堆,每次合并花费的代价为这两堆石子的和,经过N-1次合并后成为一堆.求出总的代价最小值. tags:最基本的区间dp,这题范围小,如果n大一些,还是要加个平行四边行优化. #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring&g

Luogu P2734 游戏 A Game 区间DP

P2734 游戏 A Game 题目背景 有如下一个双人游戏:N(2 <= N <= 100)个正整数的序列放在一个游戏平台上,游戏由玩家1开始,两人轮流从序列的任意一端取一个数,取数后该数字被去掉并累加到本玩家的得分中,当数取尽时,游戏结束.以最终得分多者为胜. 题目描述 编一个执行最优策略的程序,最优策略就是使玩家在与最好的对手对弈时,能得到的在当前情况下最大的可能的总分的策略.你的程序要始终为第二位玩家执行最优策略. 输入输出格式 输入格式: 第一行: 正整数N, 表示序列中正整数的个数